#include "portingGNUBoy.h"
#include "fb.h"
#include "pcm.h"
#include "hw.h"
#include "mem.h"
#include "cpuregs.h"
#include "lcd.h"
#include "regs.h"

#include <SGL.H>
#include <stdlib.h>
#include <stdio.h>

struct fb fb;

// my own frameskip stuff
int frameskip_key, frameskip_count;

//Uint16 buttons_old;
Uint16 framebuffer[144*LCD_BUF_WIDTH];

void doevents()
{
    Uint16 data = Smpc_Peripheral[0].data; //, changed = buttons_old ^ data;

#if 0
    // we may have passed the button push and pull events
    // so monitor button changes on my own
#define SET_PAD(SAT, GB) \
    if((changed & SAT) == 1) {\
        if((data & SAT) == 0)\
            pad_press(GB);\
        else pad_release(GB);\
    }
#else
    // !!! No, GNUBoy checks on it's own
#define SET_PAD(SAT, GB) \
    pad_set(GB, (data & SAT) == 0);
#endif
  
  /* start */
  SET_PAD(PER_DGT_ST, PAD_START);
  SET_PAD(PER_DGT_TL, PAD_SELECT);
  SET_PAD(PER_DGT_TB, PAD_B);
  SET_PAD(PER_DGT_TA, PAD_A);
  SET_PAD(PER_DGT_KU, PAD_UP);
  SET_PAD(PER_DGT_KD, PAD_DOWN);
  SET_PAD(PER_DGT_KL, PAD_LEFT);
  SET_PAD(PER_DGT_KR, PAD_RIGHT);
}


void gb_vid_preinit()
{
}
unsigned int frame;

void gb_vid_init()
{
	fb.w = LCD_BUF_WIDTH; //160;
	fb.h = 144;
	fb.pelsize = 2;
	fb.pitch = LCD_BUF_WIDTH; //160;//512; // not directly to VRAM
	fb.ptr = (byte *)framebuffer;
	fb.enabled = 1;
	fb.dirty = 1;
	
	fb.indexed = 0;
	fb.cc[0].r = fb.cc[1].r = fb.cc[2].r = 3;
	fb.cc[0].l = 0;
	fb.cc[1].l = 5;
	fb.cc[2].l = 10;
}


void gb_vid_close()
{
}

void vid_settitle(char *title)
{
}

void vid_setpal(int i, int r, int g, int b)
{
    were_here("i%i r%i g%i b%i", i, r, g, b);
}


void vid_begin()
{
}

int rest_frames, drop_frames;
void vid_end()
{
    char str[41];
    
    EMST_frames(1);
    if (fb.enabled) {
        EMST_start(EMST_VRAM);  
        // some display
        EMST_display();
        slPrintHex(frameskip_key, slLocate(15, 27));
        slPrintHex(frame, slLocate(15, 28));

#if 1
        // transfer to VRAM
        {
            int i, j;
            Uint16 *ptr = (Uint16 *)VDP2_VRAM_A0;
        
            for(i = 0; i < 144; i++) {
                for(j = 0; j < LCD_SCREEN_WIDTH; j++) {
                    *(ptr + i*512 + j) = framebuffer[i*LCD_BUF_WIDTH + LCD_SIDE_MARGIN + j] | RGB_Flag;
                }
            }
        }    
#endif     
//fb.ptr = (byte *)framebuffer;
#if 0
        // debug display
//    clearText();
        snprintf(str, 40, "rom: %s frame: %i", rom.name, frame);
        slPrint(str, slLocate(5, 4));

        snprintf(str, 40, "PC %08X", PC);
        slPrint(str, slLocate(5, 6));
        snprintf(str, 40, "xPC %08X, xSP %08X", xPC, xSP);
        slPrint(str, slLocate(5, 7));
        snprintf(str, 40, "xAF %08X, xBC %08X", xAF, xBC);
        slPrint(str, slLocate(5, 8));
        snprintf(str, 40, "xDE %08X, xHL %08X", xDE, xHL);
        slPrint(str, slLocate(5, 9));
        snprintf(str, 40, "IMA %08X, IME %08X", IMA, IME);
        slPrint(str, slLocate(5, 10));
        snprintf(str, 40, "Z%i N%i H%i C%i", (F&FZ ? 1 : 0), (F&FN ? 1 : 0), (F&FH ? 1 : 0), (F&FC ? 1 : 0));
        slPrint(str, slLocate(5, 11));

        snprintf(str, 40, "col: %x", framebuffer[10]);
        slPrint(str, slLocate(5, 13));
#endif    
#if 0  
  if (drop_frames)
  {
    fb.enabled = 0;
    --drop_frames;
  }
  else 
  {
    --rest_frames;
    if (rest_frames > 0)
    {
      drop_frames = rest_frames;
      rest_frames = 0;
    }
  }
#endif  
        slSynch();
        EMST_stop();
    }    
    // enable / disable drawing according to frameskip settings
    // for next frame
    if(frameskip_count > 0) {
        fb.enabled = 0;
        frameskip_count--;
    } else {
        fb.enabled = 1;
        frameskip_count = frameskip_key;        
    }
    frame++;
}


/***********************************************************/
/*** PCM stuff *********************************************/
/***********************************************************/

/* SOUND_BUF_LEN = 2 * (rate * buffer_length_in_frames / 60.0) * (bit / 8) */
/* (format "%x" ((lambda (x) (* 2 (/ (* 44100 x) 60) (/ 16 8))) 3)) */
/* NOTE: AICA require 32-bit (or higher) alignment. */
#define SAMPLE_RATE 44100
#define SAMPLE_BITS 16
#define SOUND_BUF_LEN 0x2000

struct pcm pcm;

//static Uint8 buf[SOUND_BUF_LEN / 2] __attribute__ ((aligned (32)));

#if 0
rcvar_t pcm_exports[] =
{
	RCV_END
};
#endif

void pcm_clear_buffer()
{
//	spu_memset (dc_sound_get_baseaddr (), 0, SOUND_BUF_LEN);
}


void pcm_init()
{
	pcm.hz = SAMPLE_RATE;
    pcm.len = 0;//sizeof(buf) / 2; /* sizeof(buf) / sizeof(*(pcm.buf)) */
	pcm.stereo = 0;
	pcm.buf = NULL;//buf;
	pcm.pos = 0;
	
	pcm_clear_buffer ();
//	dc_sound_init (SAMPLE_RATE, SAMPLE_BITS, SOUND_BUF_LEN);
}


void pcm_close()
{
//	dc_sound_shutdown ();
}


/***********************************************************/
/*** loader.c stuff ****************************************/
/***********************************************************/

static const int mbc_table[256] =
{
	0, 1, 1, 1, 0, 2, 2, 0, 0, 0, 0, 0, 0, 0, 0, 3,
	3, 3, 3, 3, 0, 0, 0, 0, 0, 5, 5, 5, MBC_RUMBLE, MBC_RUMBLE, MBC_RUMBLE, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,

	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,

	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,

	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, MBC_HUC3, MBC_HUC1
};

static const int rtc_table[256] =
{
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,
	1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0
};

static const int batt_table[256] =
{
	0, 0, 0, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 1, 0, 0,
	1, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 1, 0,
	0
};

static const int romsize_table[256] =
{
	2, 4, 8, 16, 32, 64, 128, 256, 512,
	0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 128, 128, 128
	/* 0, 0, 72, 80, 96  -- actual values but bad to use these! */
};

static const int ramsize_table[256] =
{
	1, 1, 1, 4, 16,
	4 /* FIXME - what value should this be?! */
};
static int forcedmg, gbamode;

static int memfill = -1, memrand = -1;

static void initmem(void *mem, int size)
{
	char *p = mem;
	if (memrand >= 0)
	{
		srand(memrand ? memrand : time(0));
		while(size--) *(p++) = rand();
	}
	else if (memfill >= 0)
		memset(p, memfill, size);
	else
	{
		memset(p, 0, size);
	}
}

void loader_unload()
{
// rom got fixed position in low work RAM
//	if (rom.bank) free(rom.bank);
	if (ram.sbank) free(ram.sbank);
	rom.bank = NULL;
	ram.sbank = NULL;
	mbc.type = mbc.romsize = mbc.ramsize = mbc.batt = 0;
}

int rom_load(const char *romfile)
{
	byte c, *data, *header;
	int len, rlen;

    // take built-in cart
#if 0
    header = data = (byte *)malloc(gamedata_size);
    memcpy(data, gamedata, gamedata_size);
#else
// rom got fixed position in low work RAM	
//    rom.bank = header = data = (void *)gamedata;
    rom.bank = (void *)gamedata;
    header = gamedata;
    data = gamedata;
#endif    
    len = gamedata_size;
    
	memcpy(rom.name, header+0x0134, 16);
	if (rom.name[14] & 0x80) rom.name[14] = 0;
	if (rom.name[15] & 0x80) rom.name[15] = 0;
	rom.name[16] = 0;
	
#if 0
	if (!mbc.romsize) die("unknown ROM size %02X\n", header[0x0148]);
	if (!mbc.ramsize) die("unknown SRAM size %02X\n", header[0x0149]);
#endif
	
	c = header[0x0143];
	hw.cgb = ((c == 0x80) || (c == 0xc0)) && !forcedmg;
	hw.gba = (hw.cgb && gbamode);
        
//    were_here("cgb%x gba%x fdmg %x gbam %x", hw.cgb, hw.gba, forcedmg, gbamode);
    
	rlen = 16384 * mbc.romsize;
// rom got fixed position in low work RAM
//	rom.bank = (void *)realloc(data, rlen); /* data & header will be broken */
	data = header = NULL;
	if (rlen > len) memset (rom.bank + len, 0xff, rlen - len);
	
	ram.sbank = malloc(8192 * mbc.ramsize);
	
	initmem(ram.sbank, 8192 * mbc.ramsize);
	initmem(ram.ibank, 4096 * 8);
	
	mbc.rombank = 1;
	mbc.rambank = 0;

	return 1;
}

int loader_init(const char *romfile)
{
	char name[256], *p;
        
	if (!rom_load(romfile))
		return 0;
        
	vid_settitle(rom.name);
	
    // we currently perform no other loading stuff    
    return 1;
}


/***********************************************************/
/*** emu.c stuff *******************************************/
/***********************************************************/

void emu_init()
{
	
}
/*
 * emu_reset is called to initialize the state of the emulated
 * system. It should set cpu registers, hardware registers, etc. to
 * their appropriate values at powerup time.
 */

void emu_reset()
{   // no buttons pressed
//    buttons_old = 0xFFFF;
	hw_reset();
	lcd_reset();
	cpu_reset();
	mbc_reset();
	sound_reset();
}

void emu_step()
{
	cpu_emulate(cpu.lcdc);
}

void emu_run()
{
    frame = 0;
    frameskip_count = 0;
    frameskip_key = 0;

	vid_begin();
	lcd_begin();
	
	for (;;)
	{
#if 0
		vid_end();
        cpu_emulate(1);
		vid_end();
		while((Smpc_Peripheral[0].data & PER_DGT_ST) != 0)
		  slSynch();
#else
        EMST_start(EMST_CPU);	    
		cpu_emulate(2280);
		while (R_LY > 0 && R_LY < 144)
			emu_step();
			
        EMST_stop();
		
		vid_end();
		rtc_tick();
#if 0		
		sound_mix();
		if (!pcm_submit())
		{
			delay = framelen - sys_elapsed(timer);
			sys_sleep(delay);
			sys_elapsed(timer);
		}
#endif
        EMST_start(EMST_PAD);
		doevents();
		// exit emu on Z
		if((Smpc_Peripheral[0].data & PER_DGT_TZ) == 0)
		  break;
        // frameskip stuff
		if((frameskip_key > 0) && ((Smpc_Peripheral[0].data & PER_DGT_TL) == 0))
		  frameskip_key--;
		if((frameskip_key < 30) && ((Smpc_Peripheral[0].data & PER_DGT_TR) == 0))
		  frameskip_key++;

        EMST_stop();
        
		vid_begin();
		
		EMST_start(EMST_CPU);
		if (!(R_LCDC & 0x80))
			cpu_emulate(32832);
		
		while (R_LY > 0) /* wait for next frame */
			emu_step();
			
        EMST_stop();
#endif
	}
}


#if 0
void run_game(const char *filename)
{
  dc_vid_empty ();
  
  exit_game_loop = 0;
  
  gb_vid_init ();
  pcm_init ();
  mem_init ();
  
  dc_print ("loading ROM");
  if (loader_init(filename)) 
  {
    emu_reset();
    emu_run ();
    
    pcm_clear_buffer();
    loader_unload ();
  }
  
  gb_vid_close();
  pcm_close();
}
#endif

void kb_init()
{
}

void kb_close()
{
}

void kb_poll()
{
}











